// contact me if you need help understanding the functions, xeen

var rdr = {
  prefServ: Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService),
  fixup: Components.classes["@mozilla.org/docshell/urifixup;1"].getService(Components.interfaces.nsIURIFixup),
  hist: Components.classes["@mozilla.org/browser/global-history;2"].getService(Components.interfaces.nsIGlobalHistory2),
  linksToReset: new Array(),

	
  // Adds all kinds of observers & injects code in order to clean links
	init: function (all) {
    this.prefs=this.prefServ.getBranch('extensions.rdr.');
    window.removeEventListener("load",function() { rdr.init(true); }, false);    
    window.addEventListener("unload", function() { rdr.prefs = null; }, false);
    if(all) document.getElementById("content").addEventListener("click", rdr.catchClick, true);
    
    this.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
		this.prefs.addObserver("", this, false);
    
    this.updatePrefs();
    
    // For contextmenu entry
    var context=document.getElementById("contentAreaContextMenu");
    if(context) {
      context.addEventListener("popupshowing", rdr.contextMenuCheck, false);
      context.addEventListener("popuphiding", rdr.contextMenuClean, false);
    }
    
    var appcontent = document.getElementById("appcontent");
    if(appcontent) appcontent.addEventListener("DOMContentLoaded", this.cleanImgs, true);
    
    // Code injecting functions need to be delayed
    if(all) window.setTimeout("rdr.delayedInit();",10);  
	},
  
  delayedInit: function() {  
    // For URLs in the statusbar
    if(nsBrowserStatusHandler) {
      eval("nsBrowserStatusHandler.prototype.setOverLink="+nsBrowserStatusHandler.prototype.setOverLink.toString().replace(
      'link;',
      '(link ? rdr.cleanLink(link,true,false) : link);'
      ));
    }    
   
    try {
      // TabMix function "open multiple links". This might change in future versions, so additional checking might be needed
      if(window.openMultipleLinks) {
        eval("openMultipleLinks="+openMultipleLinks.toString().replace(
        'newTab =',
        'nextEpisode.href=rdr.cleanLink(nextEpisode.href,false,true); newTab ='
        ));
      } 
    } catch(e){}
    
    try {
      // AiO-Gestures should use cleaned links 
      if(window.aioGetHRef) {
        eval("aioGetHRef="+aioGetHRef.toString().replace(
        'node.href',
        'rdr.cleanLink(node.href,false,true);'
        ));
        eval("aioGetHRef="+aioGetHRef.toString().replace(
        'makeURLAbsolute(node.baseURI, node.getAttributeNS(xlinkNS, "href"))',
        'rdr.cleanLink(makeURLAbsolute(node.baseURI, node.getAttributeNS(xlinkNS, "href")),false,true);'
        ));
      }
    } catch(e){}
    
    try {
      // Smart Middle Click shouldn't open links if RDR can do it instead
      if(window.contentAreaClick2) {
        eval("contentAreaClick2="+contentAreaClick2.toString().replace(
        'wrapper = linkNode;',
        'wrapper = linkNode; '+
        'if(wrapper.href!=rdr.cleanLink(wrapper.href,false,false)) return false;'
        ));
      } 
    } catch(e){}
  },
  
  catchClick: function(aEvent) {
    if (aEvent.button!= 2 && rdr.contentAreaClick(aEvent)) // button=2 == right click
		  aEvent.stopPropagation();
  },
  
  contentAreaClick: function(event) {
    var target = event.target;
  	var linkNode;

  	if (target instanceof HTMLAnchorElement || target instanceof HTMLAreaElement || target instanceof HTMLLinkElement) {
  		if (target.hasAttribute("href")) linkNode = target;
  	} else {
  		linkNode = event.originalTarget;
  		while (linkNode && !(linkNode instanceof HTMLAnchorElement)) linkNode = linkNode.parentNode;        
  		if (linkNode && !linkNode.hasAttribute("href")) linkNode = null;
  	}
    
  	var wrapper = null;
  	if (linkNode) {
  		wrapper = linkNode;

      clean=this.cleanLink(wrapper.href,false,true);
      if(clean==wrapper.href) return false;
      
      // Add uncleaned link to history as well, so it's displayed as visited
      this.addURLToHistory(wrapper.href,linkNode);
      
  		handleLinkClick(event, clean, linkNode);      
      return true;
  	}

  	return false;
  },
  
  addURLToHistory: function(url,node) {
    uri = this.fixup.createFixupURI(url, 0);

    if (!this.hist.isVisited(uri)) {
      this.hist.addURI(uri, false, true, null);
      var oldHref = node.getAttribute("href");
      if (typeof oldHref == "string") {
        node.setAttribute("href", "");
        node.setAttribute("href", oldHref);
      }
    }
    return url;
  },
    
  cleanImgs: function(e) {
    var doc = e.originalTarget;
    if(doc.nodeName != "#document" || !rdr.cleanImgsOnLoad || !doc.images || doc.images.length==0) return;
    for(i=0;i<doc.images.length;i++) {
      tmp=doc.images[i].src;
      doc.images[i].src=rdr.cleanLink(doc.images[i].src,false,true);
      if(tmp!=doc.images[i].src) doc.images[i].setAttribute("origsrc",tmp);
    }
  },
    
  updatePrefs: function() {
    this.whitelist        = this.prefs.getCharPref("whitelist").toLowerCase().split(" ");
    this.contextWhitelist = this.prefs.getBoolPref("contextmenu.whitelist");
    this.contextCopyClean = this.prefs.getBoolPref("contextmenu.copyclean");
    this.contextOpen      = this.prefs.getBoolPref("contextmenu.contextopen");
    this.contextOpenIn    = this.prefs.getIntPref ("contextmenu.contextopen.in");
    this.cleanImgsOnLoad  = this.prefs.getBoolPref("cleanImages");
    this.enabled          = this.prefs.getBoolPref("enabled");
    
    try {
      b=document.getElementById('rdr-button');    
      b.setAttribute('isenabled',this.enabled);
      b.setAttribute('label',document.getElementById("rdrLocale").getString(this.enabled?"rdrDisable":"rdrEnable"));
    } catch(e) {}
  },
    
  contextMenuCheck: function() {
    if(gContextMenu) {
      link=unescape(gContextMenu.linkURL);
      isOnList=rdr.isWhitelisted(link);
      cleanedLink=rdr.removeR(link,false,false);
      containsR=gContextMenu.onLink && (link!=cleanedLink);
      if(containsR) {
        rdr.origlinkURL=new Array(gContextMenu.link,gContextMenu.linkURL);
        gContextMenu.linkURL=cleanedLink;
        gContextMenu.link.setAttribute("href",cleanedLink);
      }
      document.getElementById('rdr-copy-clean-link').hidden =!(containsR && rdr.contextCopyClean);
      document.getElementById('rdr-add-to-list').hidden     =!(containsR && !isOnList && rdr.contextWhitelist);
      document.getElementById('rdr-remove-from-list').hidden=!(containsR &&  isOnList && rdr.contextWhitelist);
      document.getElementById('rdr-open-cleaned').hidden    =!(containsR && (!rdr.enabled || isOnList) && rdr.contextOpen);
      document.getElementById('rdr-open-uncleaned').hidden  =!(containsR && (rdr.enabled && !isOnList) && rdr.contextOpen);
    }
  },
  
  contextMenuClean: function() {
    if(rdr.origlinkURL) {
      rdr.origlinkURL[0].setAttribute('href',rdr.origlinkURL[1]);
      rdr.origlinkURL=null;
    }
  },
  
  addLinkToList: function(link) {
    host=this.getHost(unescape(link));
    //this.d(host+' ++ '+link);
    if(!link || !host) return;
    wl=this.prefs.getCharPref("whitelist");
    if(wl.length>0) wl=wl+' ';
    this.prefs.setCharPref('whitelist',(wl+host).toLowerCase());
  },
  
  removeLinkFromList: function(link) {
    host=this.getHost(unescape(link));
    //this.d(host+' ++ '+link);
    if(!link || !host) return;
    wl=' '+this.prefs.getCharPref("whitelist")+' ';
    this.prefs.setCharPref('whitelist',(wl.replace(" "+host+" ",' ')).replace(/^\s*|\s*$/g,""));
  },
  
  copyCleanLink: function() {
    if(gContextMenu) { 
      var oClipBoard = Components.classes["@mozilla.org/widget/clipboardhelper;1"].getService(Components.interfaces.nsIClipboardHelper);
      oClipBoard.copyString(rdr.removeR(gContextMenu.linkURL,false,true));
    }
  },
  
  openLink: function(link) {
    switch (rdr.contextOpenIn) {
      case 0: // here
        loadOneOrMoreURIs(link);
        break;
      case 2: // new window
        window.open(link);
        break;
      default: // new tab
        var t = gBrowser.addTab(link);
        if(!this.prefServ.getBoolPref('browser.tabs.loadInBackground')) {
          gBrowser.selectedTab = t;
          content.focus();
        }
    }
  },
  
  cleanLink: function(link,app,needsUnescape) {
    if(this.isWhitelisted(link) || !this.enabled) return link;
    return this.removeR(link,app,needsUnescape);
  },
  
  isWhitelisted: function(link) {    
    var host=this.getHost(link);  
    if(this.whitelist.length==0 || host.length==0 || link.length==0) return false;
    for (var i in this.whitelist) if(host==this.whitelist[i]) return true;
    return false;  
  },
  
  getHost: function (link) {
    var url=link.match(/\/\/(.*?)(?:\/|\?)/);
    return (url ? url[1] : link).toLowerCase();
  },
  
  removeR: function(linkOrig,app,needsUnescape) {
    if(app) a='RDR: '; else a='';
    link=needsUnescape?unescape(linkOrig):linkOrig;
    
    // Huge thanks to jumplink!
    // uggc|sgc|uggcf matches rot13 encoded URLs
  	var re = new RegExp;
  	re.compile("\\S\\/.*((?:http|ftp|https|uggc|sgc|uggcf)(?:[:]|%3a|%253a)[^&]+)", "gi");
  	if((r = link.match(re))) {
  		var ret = RegExp.$1;
      if(ret.indexOf('www.')==0) ret='http://'+ret;
  		if (ret.indexOf('%253a')) {
  			if (link.toLowerCase().indexOf('javascript') == 0) {
  				if (ret.match(/(.+?)[^-%a-z0-9:\/&]+$/gi))
  					return a+this.deRot13(unescape(RegExp.$1));
  				else
  					return a+this.deRot13(ret);		
  			}
  			return a+this.deRot13(unescape(ret));
  		} else {
  			return a+this.deRot13(ret);
  		}
  	}
  	
  	if (link.toLowerCase().indexOf('javascript') == 0) {
  		link2 = link.substr(link.indexOf('http'));
  		if((r = link2.match(re))) {
  			var ret = RegExp.$1;
         if(ret.indexOf('www.')==0) ret='http://'+ret;
  			if (ret.indexOf('%253a')) {
  				return a+this.deRot13(unescape(ret));
  			} else {
  				return a+this.deRot13(ret);
  			}
  		}
  	}
    return linkOrig;
  },
		
	deRot13: function(s){
    sb=s.toLowerCase();
    if(!(sb.indexOf('uggc:')>=0 || sb.indexOf('sgc:')>=0 || sb.indexOf('uggcf:')>=0)) return s;
    
    var list ='abcdefghijklmnopqrstuvwxyzabcdefghijklm';
    var list2='ABCDEFGHIJKLMNOPQRSTUVWXYZABCDEFGHIJKLM';
    var r='';
    for (var x = 0; x <= s.length; x++) {
      rot13 = s.substring(x, x+1);
      if (rot13 >= 'a' && rot13 <= 'z') 
        rot13 = list.charAt(list.indexOf(rot13) + 13);
      else if (rot13 >= 'A' && rot13 <= 'Z') 
        rot13 = list2.charAt(list.indexOf(rot13) + 13);
      r+=rot13;
    }
    
		return r;
  },	
  
  observe: function (subject, topic, data) {
		if (topic == "nsPref:changed") {
			this.updatePrefs();
		}
	},
  
  // MetaData Functions
  showAddRemButtons: function(add,rem,id) {
    document.getElementById("rdr-add-to-list-"+id).hidden=!add; 
    document.getElementById("rdr-remove-from-list-"+id).hidden=!rem;
  },
  
	d: function(t) {
	  Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService).logStringMessage('rdr: '+t);
  }	
}